package cz.cvut.and.tutorial03;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract.Contacts;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;
import cz.cvut.fit.tutorial03.R;

public class Tutorial03Activity extends Activity {
	private static final String STATE_KEY_CONTACT = "contact";
	private static final int PICK_REQUEST = 1;
	private Uri mContact = null;
	private Button mViewButton;

	OnClickListener pickerListener = new OnClickListener() {
		@Override
		public void onClick(View v) {
			Intent intent = new Intent(Intent.ACTION_PICK, Contacts.CONTENT_URI);
			startActivityForResult(intent, PICK_REQUEST);
		}
	};

	OnClickListener viewListener = new OnClickListener() {
		@Override
		public void onClick(View v) {
			if (mContact != null) {
				Intent intent = new Intent(Intent.ACTION_VIEW, mContact);
				startActivity(intent);
			}
		}
	};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		if (savedInstanceState != null) {
			if (savedInstanceState.containsKey(STATE_KEY_CONTACT)) {
				mContact = Uri.parse(savedInstanceState.getString(STATE_KEY_CONTACT));
			}
		}

		Button pickButton = (Button) findViewById(R.id.pickerButton);
		pickButton.setOnClickListener(pickerListener);

		mViewButton = (Button) findViewById(R.id.viewButton);
		mViewButton.setOnClickListener(viewListener);

		mViewButton.setEnabled(mContact != null);
		
		Toast.makeText(this, "Ahoj uzivateli.", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == PICK_REQUEST && resultCode == RESULT_OK) {
			mContact = data.getData();
			mViewButton.setEnabled(true);
			Toast.makeText(this, R.string.contact_picked, Toast.LENGTH_LONG).show();
			Log.d("Tutorial03Activity", "Contact picked: " + mContact);
		}
	}

	@Override
	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		if (mContact != null) {
			outState.putString(STATE_KEY_CONTACT, mContact.toString());
		}
	}

}